(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@ng-bootstrap/ng-bootstrap/index')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', '@ng-bootstrap/ng-bootstrap/index'], factory) :
	(factory((global['ng-bootstrap-nested-select'] = {}),global.core,global.common,global.index));
}(this, (function (exports,core,common,index) { 'use strict';

var NgBootstrapNestedSelectComponent = (function () {
    function NgBootstrapNestedSelectComponent() {
        this.options = [];
        this.default = {};
        this.selected = new core.EventEmitter();
        this.level = 1;
        this._selected = '';
    }
    /**
     * @return {?}
     */
    NgBootstrapNestedSelectComponent.prototype.ngOnInit = function () {
        if (!this.settings.field)
            this.settings.field = 'options';
        if (!this.settings['scroll'])
            this.settings.scroll = true;
        if (!this.settings['top'])
            this.settings.top = false;
        this._selected = this.default;
    };
    /**
     * @param {?} event
     * @param {?} option
     * @return {?}
     */
    NgBootstrapNestedSelectComponent.prototype.selectOption = function (event, option) {
        if (option[this.settings.field].length)
            event.stopPropagation();
        else {
            this._selected = option;
            this.selected.emit(this._selected);
        }
    };
    return NgBootstrapNestedSelectComponent;
}());
NgBootstrapNestedSelectComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'nested-select',
                template: "<ng-template #optionTemplate let-options=\"options\" let-i=\"index\"> <ng-template ngFor [ngForOf]=\"options\" let-opt> <div class=\"index-{{i}} option\" (click)=\"selectOption($event, opt)\" [ngClass]=\"{'dropdown-item': !opt[settings.field].length}\">{{opt.name}}</div> <div class=\"option-container\" *ngIf=\"opt[settings.field].length\"> <ng-container [ngTemplateOutlet]=\"optionTemplate\" [ngOutletContext]=\"{options: opt[settings.field], index: (i+1)}\"></ng-container> </div> </ng-template> </ng-template> <div ngbDropdown class=\"nested-select\"> <div ngbDropdownToggle id=\"dropdownMenuButton\"> {{_selected.name}} </div> <div ngbDropdownMenu aria-labelledby=\"dropdownMenuButton\" [ngClass]=\"{'scroll': settings.scroll, 'top': settings.top}\"> <ng-template ngFor [ngForOf]=\"options\" let-opt let-i=\"index\"> <div class=\"index-0 option\" (click)=\"selectOption($event)\">{{opt.name}}</div> <div class=\"option-container\" *ngIf=\"opt[settings.field].length\"> <ng-container [ngTemplateOutlet]=\"optionTemplate\" [ngOutletContext]=\"{options: opt[settings.field], index: level}\"></ng-container> </div> </ng-template> </div> </div> ",
                styles: [".nested-select { border: none; padding: 0; margin: 0; height: 100%; width: 100%; position: relative; } .nested-select .dropdown-toggle::after { float: right; position: relative; top: 40%; } .nested-select .dropdown-menu { width: 100%; } .nested-select .dropdown-menu.scroll { overflow-y: scroll; max-height: 300px; } .nested-select .dropdown-menu.top { top: -300px !important; } .nested-select dropdown-menu.show { left: 0; } .nested-select .dropdown-toggle { height: 100%; width: 100%; cursor: pointer; } .nested-select .option { padding: 0 .5rem; font-style: italic; } .nested-select .index-0 { padding: 0 .5rem; font-weight: bold; font-style: normal; } .nested-select .dropdown-item { color: #000; cursor: pointer; font-style: normal; } .nested-select .option-container { border-left: 1px solid #EEE; margin-left: .8rem; } "]
            },] },
];
/**
 * @nocollapse
 */
NgBootstrapNestedSelectComponent.ctorParameters = function () { return []; };
NgBootstrapNestedSelectComponent.propDecorators = {
    'options': [{ type: core.Input },],
    'default': [{ type: core.Input },],
    'settings': [{ type: core.Input },],
    'selected': [{ type: core.Output },],
};

var NgBootstrapNestedSelectModule = (function () {
    function NgBootstrapNestedSelectModule() {
    }
    return NgBootstrapNestedSelectModule;
}());
NgBootstrapNestedSelectModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule,
                    index.NgbModule
                ],
                declarations: [NgBootstrapNestedSelectComponent],
                exports: [NgBootstrapNestedSelectComponent]
            },] },
];
/**
 * @nocollapse
 */
NgBootstrapNestedSelectModule.ctorParameters = function () { return []; };

exports.NgBootstrapNestedSelectModule = NgBootstrapNestedSelectModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
